<template>
  <label :class="[!title ? 'simple' : '', 'c-radio']">
    <input
      type="radio"
      :name="name"
      :value="value"
      :checked="isChecked"
      @change="(e) => handleChange(e)"
    />
    <span class="c-radio__mark"></span>
    {{ title }}
  </label>
</template>

<script setup>
import { computed, defineProps, defineEmits } from 'vue';

const props = defineProps({
  modelValue: [Number, String],
  value: [Number, String],
  name: String,
  title: String
});

const isChecked = computed(() => props.modelValue === props.value);

const emit = defineEmits(['update:modelValue']);
const handleChange = ($event) => {
  let value = $event.target.value;
  if (typeof props.modelValue === 'number') {
    value = +value;
  }
  emit('update:modelValue', value);
};
</script>

<style lang="scss" scoped>
.c-radio {
  position: relative;
  display: flex;
  align-items: center;
  padding-left: 30px;
  input {
    position: absolute;
    opacity: 0;
    top: 0;
    left: 0;
  }

  &.simple {
    padding-left: 20px;
    height: 20px;
  }

  &__mark {
    width: 20px;
    height: 20px;
    position: absolute;
    top: 50%;
    left: 0;
    transform: translateY(-50%);
    &::after {
      content: '';
      position: absolute;
      opacity: 0;
      transition: ease-in-out 0.2s;
    }
  }

  input[type='radio'] + .c-radio__mark {
    @extend .c-radio__mark;
    border-radius: 50%;
    border: 1px solid royalblue;
    &::after {
      border-radius: 50%;
      width: 80%;
      height: 80%;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      background: royalblue;
    }
  }

  input:checked + .c-radio__mark::after {
    opacity: 1;
  }
}
</style>
